/* Byteweises Senden und Empfangen von Dateien					*/

#include <tos.h> 
#include <vdi.h>
#include <aes.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "DATAMOVE.H"

int	work_in[12],work_out[57];

int ap_id;
int p_handle,handle;
int zb,zh,bb,bh;
int m_x,m_y,m_f;

int msg[8];								/* Mitteilungspuffer	*/

OBJECT *menu;

char pfad[128],name[128];

int	 interface;							/* RS232C (1), MIDI (3)	*/


/* ------------------------------------------------------------ */


void open_work(void)
	{
	int i;
	ap_id=appl_init();					/* Applikationsnummer	*/
	p_handle=graf_handle(&zb,&zh,&bb,&bh); /* Bildschirm-Handle	*/
	for(i=0; i<10; i++) work_in[i]=1;	/* Auf Eins setzen		*/
	work_in[10]=2;						/* Koordinatensystem	*/
	handle=p_handle;					/* Kopieren				*/
	v_opnvwk(work_in,&handle,work_out);	/* Virtuelle erffnen	*/
	m_x=work_out[0];
	m_y=work_out[1];
	m_f=work_out[39];
	}


void close_work(void)
	{
	v_clsvwk(handle);					/* Virtuelle abmelden	*/
	appl_exit();						/* Anwendung abmelden	*/
	}


/* ------------------------------------------------------------ */


long eingabe_zahl(void)
	{
	OBJECT	*dialog;
	int		dx,dy,db,dh;
	char	*e_anz;
	long	anzahl;
	int		endob;

	
	rsrc_gaddr(R_TREE,DIALOG,&dialog);		/* Objektadresse	*/

/* Kursor an den Anfang setzen									*/
	strcpy(dialog[ZAHL].ob_spec.tedinfo->te_ptext,"");

	form_center(dialog,&dx,&dy,&db,&dh);	/* Zentrieren		*/

/* Speicherplatz fr verdeckten Bereich reservieren 			*/
	form_dial(FMD_START,dx,dy,db,dh,dx,dy,db,dh);

/* Animationseffekt - wachsendes Rechteck						*/
	form_dial(FMD_GROW,dx+db/2,dy+dh/2,1,1,dx,dy,db,dh);

/* Dialogbox zeichnen											*/
	objc_draw(dialog,ROOT,MAX_DEPTH,dx,dy,db,dh);

/* Textfeld mit Cursor aktivieren								*/
	endob=form_do(dialog,ZAHL);

/* Textfeld deselektieren										*/
	objc_change(dialog,endob,0,dx,dy,db,dh,NORMAL,1);	
	
/* Dialogbox mit schrumpfenden Rechteck entfernen				*/
	form_dial(FMD_SHRINK,dx+db/2,dy+dh/2,1,1,dx,dy,db,dh);

/* Speicherplatz freigeben										*/
	form_dial(FMD_FINISH,dx,dy,db,dh,dx,dy,db,dh);
	
/* Eingabe auswerten											*/
	e_anz=dialog[ZAHL].ob_spec.tedinfo->te_ptext;
	sscanf(e_anz,"%6ld",&anzahl);
	
	return(anzahl);
	}


void dateiauswahl(void)
	{
	char	dateiname[80]="";
	int		knopf;
	char	*such;

	name[0]=0;
	fsel_input(pfad,dateiname,&knopf);
	if((knopf==1)&&(strlen(dateiname)))
		{
		strcpy(name,pfad);
		such=strrchr(name,'\\');
		if(such==NULL)
			strcpy(name,dateiname);
		else
			strcpy(++such,dateiname);
		}
	}


void lout_aschex(unsigned int wert, char *zeiger)
	{
	int	i;
	unsigned char	zeichen;
	unsigned int	hilf;

	for(i=12; i>=0; i=i-4)
		{
		hilf=wert;
		hilf=hilf>>i;
		hilf=hilf & 0x0F;
		zeichen=hilf+0x30;
		if(zeichen>0x39)
			zeichen=zeichen+7;
		*zeiger=zeichen;
		zeiger++;
		}
	*zeiger=0;
	}


void pruefsumme(unsigned long cks)
	{
	char	hilf[5],text[80]="[1][ | Prfsumme:  |    ";

	lout_aschex((unsigned int)cks,hilf);
	strcat(text,hilf);
	strcat(text,"][ OK ]");
	form_alert(1,text);
	}


int	sende_zeichen(char zeichen)
	{
	int		knopf,ok=-1;

	do
		{
		if(Cconis()==-1)
			if(Crawcin()==0x610000L)
				{
				graf_mouse(ARROW,0);
				knopf=form_alert(1,"[2][ | Senden abbrechen?  ][Ja| Nein ]");
				if(knopf==1)
					ok=0;
				else
					graf_mouse(BUSYBEE,0);
				}
		}
	while(ok && Bcostat(interface)==0);
	if(ok)
		Bconout(interface,zeichen);
	return(ok);
	}


void sende_datei(void)
	{
	int		fehler=0;
	int		f_handle,status,knopf;
	long	f_laenge,bytes;	
	char	hilf[8],ausschrift[100]="[1][ | Es werden ";
	unsigned long	cks=0;
	unsigned char	zeichen;

	dateiauswahl();
	if(strlen(name)>0)
		{
		graf_mouse(BUSYBEE,0);	
		f_handle=open(name,O_RDONLY);
		if(f_handle==-1)
			{
			graf_mouse(ARROW,0);
			form_alert(1,"[2][ | Datei nicht gefunden! ][ Abbruch ]");
			}
		else
			{
			f_laenge=lseek(f_handle,0,SEEK_END);
			lseek(f_handle,0,SEEK_SET);
			ltoa(f_laenge,hilf,10);
			strcat(ausschrift,hilf);
			graf_mouse(ARROW,0);
			strcat(ausschrift," Bytes  | gesendet.| ...Abbruch mit UNDO  ][OK| Abbruch ]");
			if(form_alert(1,ausschrift)==1)
				{
				do
					{
					knopf=1;
					status=(int)Bcostat(interface);
					if(status==0)
						knopf=form_alert(1,"[2][ | Empfnger streikt!  ][OK| Abbruch ]");
					}
				while((status==0)&&(knopf==1));
				if(status)
					{
					graf_mouse(BUSYBEE,0);
					do
						{
						bytes=read(f_handle,&zeichen,1);
						if(bytes>0)
							if(sende_zeichen(zeichen)==0)
								fehler=-1;
							else
								cks=(cks+zeichen) & 0xFFFF;
						if(bytes==-1)
							{
							graf_mouse(ARROW,0);
							form_alert(1,"[2][ | Fehler beim Lesen  | der Datei.][ Abbruch ]");
							fehler=-1;
							}
						}
					while((bytes>0)&&(!fehler));
					graf_mouse(ARROW,0);
					if(!fehler)
						pruefsumme(cks);
					}
				}
			close(f_handle);
			}
		}
	}


void empfange_datei(void)
	{
	long	bytes,bytes_ret;
	int		ok,knopf,f_handle;
	unsigned char	zeichen,*a_buf,*i_buf;
	unsigned long	cks,i;

	bytes=eingabe_zahl();
	if(bytes!=0)
		{
		a_buf=malloc(bytes);
		if(a_buf==NULL)
			form_alert(1,"[1][ | Zu wenig freier  | Speicherplatz!][ Abbruch ]");
		else
			{
			knopf=form_alert(1,"[1][ | Wenn keine Bytes empfangen  | werden, Abbruch mit UNDO| mglich.][OK| Abbruch ]");
			if(knopf==1)
				{
				while(Bconstat(interface))	/* Empfangspuffer	*/
					Bconin(interface);		/* leeren			*/
				graf_mouse(BUSYBEE,0);
				i_buf=a_buf;
				i=0;
				ok=1;
				cks=0;
				while((i<bytes) && ok)
					if(Bconstat(interface))
						{
						zeichen=(char)Bconin(interface);
						*i_buf=zeichen;
						i_buf++;
						i++;
						cks=(cks+zeichen) & 0xFFFF;
						}
					else
						if(Cconis())
							if(Crawcin()==0x610000L)
								{
								graf_mouse(ARROW,0);
								knopf=form_alert(1,"[2][ | Empfang abbrechen?  ][Ja| Nein ]");
								if(knopf==1)
									ok=0;
								else
									graf_mouse(BUSYBEE,0);
								}
				graf_mouse(ARROW,0);
				pruefsumme(cks);
				if(i>0)
					{
					knopf=form_alert(1,"[2][ | Daten sichern?  ][Ja| Nein ]");
					if(knopf==1)
						{
						dateiauswahl();
						if(strlen(name)>0)
							{
							f_handle=creat(name);
							if(f_handle==-1)
								form_alert(1,"[2][ | Datei kann nicht  | erstellt werden!][ Abbruch ]");
							else
								{
								graf_mouse(BUSYBEE,0);
								bytes_ret=write(f_handle,a_buf,i);
								graf_mouse(ARROW,0);
								if(bytes_ret==-1)
									form_alert(1,"[2][ | Fehler beim Schreiben  | der Datei!][ Abbruch ]");
								else
									if(labs(bytes_ret)<bytes)
										form_alert(1,"[2][ | Laufwerk voll!  ][ Abbruch ]");
								close(f_handle);
								}
							}
						}
					}
				}
			free(a_buf);
			}
		}
	}


void loop(void)
	{
	int		drive,knopf;
	char	ende=0;
		
	interface=1;						/* RS232C				*/
	menu_icheck(menu,RS232C,1);
	drive=Dgetdrv();					/* aktueller LW +Pfad	*/
	pfad[0]=drive+'A';
	pfad[1]=':';
	Dgetpath(&pfad[2],0);
	strcat(pfad,"\\*.*");
	do
		{
		evnt_mesag(msg);
		if(msg[0]==MN_SELECTED)			/* Menu angewhlt		*/
			{
			switch(msg[4])				/* Welches Objekt ?		*/
				{
				case	INFORM:
					form_alert(1,"[1][ --- Puplic Domain ---   | Datenbertragung ber|    RS232C und MIDI|      Version 1.0][  OK  ]");
					break;
				case	BEENDEN:
					knopf=form_alert(1,"[2][ | Programm beenden?  ][Ja| Nein ]");
					if(knopf==1) ende=-1;
					break;
				case	SENDEN:
					sende_datei();
					break;
				case	EMPFANG:
					empfange_datei();
					break;
				case	RS232C:
					interface=1;
					menu_icheck(menu,MIDI,0);
					menu_icheck(menu,RS232C,1);
					break;
				case	MIDI:
					interface=3;
					menu_icheck(menu,RS232C,0);
					menu_icheck(menu,MIDI,1);
					break;
				}
			menu_tnormal(menu,msg[3],1);	/* Invertierung aus */
			}
		}
	while(ende==0);
	}


void main(void)
	{
	open_work();
	if(!rsrc_load("DATAMOVE.RSC"))
		form_alert(1,"[2][ | 'DATAMOVE.RSC'| nicht gefunden!  ][ Abbruch ]");
	else
		{
		rsrc_gaddr(R_TREE,MENU,&menu);	/* Adresse Objektbaum   */
		menu_bar(menu,1);				/* Menu einschalten     */
		graf_mouse(ARROW,0);			/* Pfeil als Maus		*/
		loop();							/* Hauptschleife		*/
		menu_bar(menu,0);				/* Menu ausschalten     */
		rsrc_free();
		}
	close_work();
	exit(0);
	}
